:

set -u

progname=$1

bin_wish=`./findpath.sh $progname`
if [ "Z$bin_wish" = "Z" ] ; then
  echo " $progname wasn't found in the PATH"
  exit 1
fi

# display message
echo " $progname found at $bin_wish"

`echo "exit" | $bin_wish`
errcode=$?
if [ "Z$errcode" != "Z0" ] ; then
  echo " $bin_wish cannot run (errorcode=$errcode)"
  exit 2
fi

runout=`echo "exit" | $bin_wish 2>./genemake.tmp`
if [ -s ./genemake.tmp ] ; then
  echo " $bin_wish cannot run (are you in a X session ?)"
  echo " You must be under Gnome, KDE, FVWM, X11, ... to install netwag."
  rm ./genemake.tmp
  exit 3
fi
rm ./genemake.tmp

echo "puts \$tcl_version" > ./genemake.tmp
echo "exit" >> ./genemake.tmp
ver_tcl=`cat ./genemake.tmp | $bin_wish`
rm ./genemake.tmp
echo "  -> Tcl version $ver_tcl"

echo "puts \$tk_version" > ./genemake.tmp
echo "exit" >> ./genemake.tmp
ver_tk=`cat ./genemake.tmp | $bin_wish`
rm ./genemake.tmp
echo "  -> Tk version $ver_tk"

echo "puts [expr int(\$tcl_version)]" > ./genemake.tmp
echo "exit" >> ./genemake.tmp
ver_tcl_major=`cat ./genemake.tmp | $bin_wish`
rm ./genemake.tmp
echo "  -> Tcl major version $ver_tcl_major"

echo "puts [expr int(\$tk_version)]" > ./genemake.tmp
echo "exit" >> ./genemake.tmp
ver_tk_major=`cat ./genemake.tmp | $bin_wish`
rm ./genemake.tmp
echo "  -> Tk major version $ver_tk_major"

if [ $ver_tcl_major -lt 8 ] ; then
  echo "  => program is too old (tcl==$ver_tcl<8)"
  exit 4
fi
if [ $ver_tk_major -lt 8 ] ; then
  echo "  => program is too old (tk==$ver_tk<8)"
  exit 5
fi

# ok
exit 0
