
/*-------------------------------------------------------------*/
/* rfc 977 */

/*-------------------------------------------------------------*/
typedef enum {
  NETWOX_NNTP_REPLYCODE_SVCREADY = 200,
  NETWOX_NNTP_REPLYCODE_SVCREADYNOPOST = 201,
  NETWOX_NNTP_REPLYCODE_SVCCLOSING = 205,
  NETWOX_NNTP_REPLYCODE_GROUPSELECTED = 211,
  NETWOX_NNTP_REPLYCODE_LISTFOLLOWS = 215,
  NETWOX_NNTP_REPLYCODE_ARTICLEHEADBODY = 220,
  NETWOX_NNTP_REPLYCODE_ARTICLEHEAD = 221,
  NETWOX_NNTP_REPLYCODE_ARTICLEBODY = 222,
  NETWOX_NNTP_REPLYCODE_POSTOK = 240,
  NETWOX_NNTP_REPLYCODE_SENDDATA = 340,
  NETWOX_NNTP_REPLYCODE_NOARTICLENUMBER = 423,
  NETWOX_NNTP_REPLYCODE_NOARTICLEFOUND = 430
} netwox_nntp_replycode;

/*-------------------------------------------------------------*/
netwib_err netwox_nntp_write_modereader(netwib_io *pio);
netwib_err netwox_nntp_write_group(netwib_io *pio,
                                   netwib_constbuf *pnewsgroup);
netwib_err netwox_nntp_write_article(netwib_io *pio,
                                     netwib_uint32 artnum);
netwib_err netwox_nntp_write_list(netwib_io *pio);
netwib_err netwox_nntp_write_quit(netwib_io *pio);

/*-------------------------------------------------------------*/
netwib_err netwox_nntp_write_post_begin(netwib_io *pio);
#define netwox_nntp_write_post_content(pio,pdata) netwox_smtp_write_data_content(pio,pdata)
#define netwox_nntp_write_post_end(pio) netwox_smtp_write_data_end(pio)

/*-------------------------------------------------------------*/
/* post one message (don't forget to call netwox_txtproto_io before) */
netwib_err netwox_nntp_post(netwib_bufpool *pbufpool,
                            netwib_io *pio,
                            netwib_uint32 maxwaitms,
                            netwib_constbuf *pnewsgroups,
                            netwib_constbuf *pdata);

/*-------------------------------------------------------------*/
/* download one message (don't forget to select group before) */
netwib_err netwox_nntp_download(netwib_bufpool *pbufpool,
                                netwib_io *pio,
                                netwib_uint32 maxwaitms,
                                netwib_uint32 artnum,
                                netwib_constbuf *pfilename);
