/*
                                  NETWOX
                             Network toolbox
                Copyright(c) 1999-2004 Laurent Constantin
                                  -----

  Main server    : http://www.laurentconstantin.com/
  Backup servers : http://go.to/laurentconstantin/
                   http://laurentconstantin.est-la.com/
                   http://laurentconstantin.free.fr/
                   http://membres.lycos.fr/lauconstantin/
  [my current email address is on the web servers]

                                  -----
  This file is part of Netwox.

  Netwox is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  version 2 as published by the Free Software Foundation.

  Netwox is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
  General Public License for more details (http://www.gnu.org/).

------------------------------------------------------------------------
*/

/*-------------------------------------------------------------*/
#include "../netwox.h"

/*-------------------------------------------------------------*/
netwib_err netwox_path_root_jail(netwib_bufpool *pbufpool,
                                 netwib_constbuf *prootdir,
                                 netwib_constbuf *prelfilename,
                                 netwib_buf *pabsfilename)
{
  netwib_buf *pleft, *pright, *ptmp;
  netwib_err ret;

  /* no limitation */
  if (netwib__buf_ref_data_size(prootdir) == 0) {
    netwib_er(netwib_buf_append_buf(prelfilename, pabsfilename));
    return(NETWIB_ERR_OK);
  }

  netwib_er(netwib_bufpool_buf_init(pbufpool, &ptmp));
  netwib_er(netwib_bufpool_buf_init(pbufpool, &pright));
  netwib_er(netwib_buf_append_byte('/', ptmp));
  netwib_er(netwib_buf_append_buf(prelfilename, ptmp));
  netwib_er(netwib_buf_append_byte('.', pright));
  ret = netwib_path_canon(ptmp, pright);
  netwib_er(netwib_bufpool_buf_close(pbufpool, &ptmp));
  if (ret != NETWIB_ERR_OK) {
    netwib_er(netwib_bufpool_buf_close(pbufpool, &pright));
    return(ret);
  }

  netwib_er(netwib_bufpool_buf_init(pbufpool, &pleft));
  netwib_er(netwib_path_canon(prootdir, pleft));

  netwib_er(netwib_path_init_concat(pleft, pright, pabsfilename));
  netwib_er(netwib_bufpool_buf_close(pbufpool, &pleft));
  netwib_er(netwib_bufpool_buf_close(pbufpool, &pright));

  return(NETWIB_ERR_OK);
}
