
/*-------------------------------------------------------------*/
/* rfc 2821 */

/*-------------------------------------------------------------*/
typedef enum {
  NETWOX_SMTP_REPLYCODE_SVCREADY = 220,
  NETWOX_SMTP_REPLYCODE_SVCCLOSING = 221,
  NETWOX_SMTP_REPLYCODE_OK = 250,
  NETWOX_SMTP_REPLYCODE_OKNOTLOCAL = 251,
  NETWOX_SMTP_REPLYCODE_OKSENDDATA = 354
} netwox_smtp_replycode;

/*-------------------------------------------------------------*/
/* HELO domain CRLF */
netwib_err netwox_smtp_write_helo(netwib_io *pio,
                                  netwib_constbuf *pdomain);

/*-------------------------------------------------------------*/
/* [cmd]:<toto@example.com> CRLF */
netwib_err netwox_smtp_write_email(netwib_io *pio,
                                   netwib_conststring cmd,
                                   netwib_constbuf *pemail);
#define netwox_smtp_write_email_mailfrom(pio,pemail) netwox_smtp_write_email(pio,"MAIL FROM",pemail)
#define netwox_smtp_write_email_rcptto(pio,pemail) netwox_smtp_write_email(pio,"RCPT TO",pemail)

/*-------------------------------------------------------------*/
/* DATA */
netwib_err netwox_smtp_write_data_begin(netwib_io *pio);
/* notes :
    - pdata must contain lines terminated by "\r\n"
    - last call to content has to end with "\r\n"
*/
netwib_err netwox_smtp_write_data_content(netwib_io *pio,
                                          netwib_constbuf *pdata);
netwib_err netwox_smtp_write_data_end(netwib_io *pio);

/*-------------------------------------------------------------*/
/* QUIT */
netwib_err netwox_smtp_write_quit(netwib_io *pio);

/*-------------------------------------------------------------*/
/* send one mail (don't forget to call netwox_txtproto_io before) */
netwib_err netwox_smtp_send(netwib_bufpool *pbufpool,
                            netwib_io *pio,
                            netwib_uint32 maxwaitms,
                            netwib_constbuf *pmailfrom,
                            netwib_constbuf *prcptto,
                            netwib_constbuf *pdata);
