/*
                                  NETWOX
                             Network toolbox
                Copyright(c) 1999-2004 Laurent Constantin
                                  -----

  Main server    : http://www.laurentconstantin.com/
  Backup servers : http://go.to/laurentconstantin/
                   http://laurentconstantin.est-la.com/
                   http://laurentconstantin.free.fr/
                   http://membres.lycos.fr/lauconstantin/
  [my current email address is on the web servers]

                                  -----
  This file is part of Netwox.

  Netwox is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  version 2 as published by the Free Software Foundation.

  Netwox is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
  General Public License for more details (http://www.gnu.org/).

------------------------------------------------------------------------
*/

/*-------------------------------------------------------------*/
#include "../netwox.h"

/*-------------------------------------------------------------*/
netwox_toolarg t000001_args[] = {
  NETWOX_TOOLARG_OPT_BOOL('d', "devices", "display devices", NULL, NULL),
  NETWOX_TOOLARG_OPT_BOOL('i', "ip", "display ip addresses", NULL, NULL),
  NETWOX_TOOLARG_OPT_BOOL('a', "arpcache", "display arp cache and neighbors",
                         NULL, NULL),
  NETWOX_TOOLARG_OPT_BOOL('r', "routes", "display routes", NULL, NULL),
  NETWOX_TOOLARG_END
};
netwox_tooltreenodetype t000001_nodes[] = {
  NETWOX_TOOLTREENODETYPE_INFO_LOCAL,
  NETWOX_TOOLTREENODETYPE_END
};
netwox_tool_info t000001_info = {
  "Display network configuration",
  "If no option is set, they are all displayed",
  t000001_args,
  t000001_nodes,
};

/*-------------------------------------------------------------*/
netwib_err t000001_core(int argc, char *argv[])
{
  netwox_arg *parg;
  netwib_bool wantd, wanti, wanta, wantr, disp;

  netwib_er(netwox_arg_init(argc, argv, &t000001_info, &parg));
  netwib_er(netwox_arg_bool(parg, 'd', &wantd));
  netwib_er(netwox_arg_bool(parg, 'i', &wanti));
  netwib_er(netwox_arg_bool(parg, 'a', &wanta));
  netwib_er(netwox_arg_bool(parg, 'r', &wantr));
  netwib_er(netwox_arg_close(&parg));

  disp = NETWIB_FALSE;
  if (wantd) {
    netwib_er(netwib_conf_devices_display());
    disp = NETWIB_TRUE;
  }
  if (wanti) {
    netwib_er(netwib_conf_ip_display());
    disp = NETWIB_TRUE;
  }
  if (wanta) {
    netwib_er(netwib_conf_arpcache_display());
    disp = NETWIB_TRUE;
  }
  if (wantr) {
    netwib_er(netwib_conf_routes_display());
    disp = NETWIB_TRUE;
  }

  if ( ! disp) {
    netwib_er(netwib_conf_display());
  }

  return(NETWIB_ERR_OK);
}
