/*
                                  NETWOX
                             Network toolbox
                Copyright(c) 1999-2004 Laurent Constantin
                                  -----

  Main server    : http://www.laurentconstantin.com/
  Backup servers : http://go.to/laurentconstantin/
                   http://laurentconstantin.est-la.com/
                   http://laurentconstantin.free.fr/
                   http://membres.lycos.fr/lauconstantin/
  [my current email address is on the web servers]

                                  -----
  This file is part of Netwox.

  Netwox is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  version 2 as published by the Free Software Foundation.

  Netwox is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
  General Public License for more details (http://www.gnu.org/).

------------------------------------------------------------------------
*/

/*-------------------------------------------------------------*/
#include "../netwox.h"

/*-------------------------------------------------------------*/
netwox_toolarg t000099_args[] = {
  NETWOX_SOCK_ARG_TCP_CLIPORT("23"),
  NETWOX_TOOLARG_END
};
netwox_tooltreenodetype t000099_nodes[] = {
  NETWOX_TOOLTREENODETYPE_CLIENT_TCP_TELNET,
  NETWOX_TOOLTREENODETYPE_END
};
netwox_tool_info t000099_info = {
  "TELNET client",
  "It works line by line (ie vi is not correctly supported)",
  t000099_args,
  t000099_nodes,
};

/*-------------------------------------------------------------*/
netwib_err t000099_core(int argc, char *argv[])
{
  netwox_arg *parg;
  netwox_sockinfo sockinfo;
  netwib_io *ptcpio, *ptelnetio;

  /* obtain parameters */
  netwib_er(netwox_arg_init(argc, argv, &t000099_info, &parg));
  netwib_er(netwox_sockinfo_init_arg_tcp_cli(parg, &sockinfo));

  /* create a telnet io, and plug it on top of tcpio */
  netwib_er(netwox_sock_init(&sockinfo, &ptcpio));
  netwib_er(netwox_telnet_init(&ptelnetio));
  netwib_er(netwib_io_plug_rdwr(ptelnetio, ptcpio));

  /* main loop */
  netwib_er(netwox_io_kbd_loop(ptelnetio, NETWIB_FALSE, NETWIB_FALSE,
                               NETWIB_DECODETYPE_DATA,
                               NETWIB_ENCODETYPE_DATA));

  /* close */
  netwib_er(netwib_io_close(&ptelnetio));
  netwib_er(netwox_sockinfo_close(&sockinfo));
  netwib_er(netwox_arg_close(&parg));

  return(NETWIB_ERR_OK);
}
