:

set -u

if [ $# -ne 3 ] ; then
  echo "Usage : $0 program display[0_1] ad,ad,ad,ad"
  exit 1
fi

program=$1
display=$2
addresses=$3

# should use mktemp, but does not work under Solaris
tmpconf="./tmp_bt_1"

echo "set listsize 5" > $tmpconf

echo $addresses | tr ',' '\012' | while read aline
do
  echo "l *$aline" >> $tmpconf
done
echo "quit" >> $tmpconf

tmpfile="./tmp_bt_2"
(echo "quit" | gdb -q -x $tmpconf $program ) 2>/dev/null |\
   grep "is in" > $tmpfile
rm $tmpconf

echo "*** warning : line is the next one ***"
if [ $display -eq 0 ] ; then
  cat $tmpfile | sed 's/^.*is in //' | sed 's|[(][.][.].*/|(|'
else
  cat $tmpfile
fi

rm $tmpfile
