#include "netwibtest.h"

/*-------------------------------------------------------------*/
static netwib_err netwib_path_canon_test(void)
{
  netwib_buf buf1, buf2;

  puts("++++----\nTest of netwib_path_canon");

  netwib_er(netwib_buf_init_ext_text("a", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_er(netwib_path_canon(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "./a"));
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("/tmp/tutu", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_er(netwib_path_canon(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "/tmp/tutu"));
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("/tmp////tutu", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_er(netwib_path_canon(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "/tmp/tutu"));
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("////tmp////tutu", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_er(netwib_path_canon(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "/tmp/tutu"));
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("////tmp/tutu", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_er(netwib_path_canon(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "/tmp/tutu"));
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("//", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_er(netwib_path_canon(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "/"));
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("/./", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_er(netwib_path_canon(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "/"));
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("aa/..", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_er(netwib_path_canon(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "."));
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("..", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_er(netwib_path_canon(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, ".."));
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("aa/./bb", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_er(netwib_path_canon(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "./aa/bb"));
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("aa/././bb", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_er(netwib_path_canon(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "./aa/bb"));
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("a/././b", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_er(netwib_path_canon(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "./a/b"));
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("/././b", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_er(netwib_path_canon(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "/b"));
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("aa/././", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_er(netwib_path_canon(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "./aa"));
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("aa/./.", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_er(netwib_path_canon(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "./aa"));
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("/./.", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_er(netwib_path_canon(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "/"));
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("aa/.", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_er(netwib_path_canon(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "./aa"));
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("aa/bb/..", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_er(netwib_path_canon(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "./aa"));
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("aa/bb/cc/..", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_er(netwib_path_canon(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "./aa/bb"));
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("aa/bb/cc/../dd", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_er(netwib_path_canon(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "./aa/bb/dd"));
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("aa/bb/cc/../dd/../ee", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_er(netwib_path_canon(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "./aa/bb/ee"));
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("aa/bb/cc/../..", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_er(netwib_path_canon(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "./aa"));
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("aa/bb/cc/../../", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_er(netwib_path_canon(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "./aa"));
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("aa/bb/cc/../../dd/../ee", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_er(netwib_path_canon(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "./aa/ee"));
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("aa/bb/../../dd/../ee", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_er(netwib_path_canon(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "./ee"));
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("aa/../..", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_er(netwib_path_canon(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, ".."));
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("aa/../../", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_er(netwib_path_canon(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, ".."));
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("aa/../../b", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_er(netwib_path_canon(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "../b"));
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("aa/../bb/../../c/d/e/../", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_er(netwib_path_canon(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "../c/d"));
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("../bb/../cc/aa", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_er(netwib_path_canon(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "../cc/aa"));
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("../bb/dd/../cc/aa/../ee", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_er(netwib_path_canon(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "../bb/cc/ee"));
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("aa/../../bb/../../../cc", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_er(netwib_path_canon(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "../../../cc"));
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("aa/../../bb/../../../cc/../../dd", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_er(netwib_path_canon(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "../../../../dd"));
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("aa/../../bb/../../../cc/../ee/dd", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_er(netwib_path_canon(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "../../../ee/dd"));
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("/..", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_eir(netwib_path_canon(&buf1, &buf2), NETWIB_ERR_SPPATHROOTDOTDOT);
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("/../../", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_eir(netwib_path_canon(&buf1, &buf2), NETWIB_ERR_SPPATHROOTDOTDOT);
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("/aa/../../", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_eir(netwib_path_canon(&buf1, &buf2), NETWIB_ERR_SPPATHROOTDOTDOT);
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("aa///////bb/.././././///./../dd///../ee",
                                     &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_er(netwib_path_canon(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "./ee"));
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("aa/..\\../bb/../..\\../cc/../ee/dd",
                                     &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_er(netwib_path_canon(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "../../../ee/dd"));
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("d:\\", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_er(netwib_path_canon(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "d:/"));
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("d:\\dir", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_er(netwib_path_canon(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "d:/dir"));
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("d:\\dir\\", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_er(netwib_path_canon(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "d:/dir"));
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("d:\\dir\\", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_er(netwib_path_canon(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "d:/dir"));
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("d:\\dir\\file", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_er(netwib_path_canon(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "d:/dir/file"));
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("d:\\dir\\..\\", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_er(netwib_path_canon(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "d:/"));
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("d:\\dir\\..\\file", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_er(netwib_path_canon(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "d:/file"));
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("d:/", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_er(netwib_path_canon(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "d:/"));
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("d:/dir", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_er(netwib_path_canon(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "d:/dir"));
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("d:/dir/", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_er(netwib_path_canon(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "d:/dir"));
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("d:/dir/file", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_er(netwib_path_canon(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "d:/dir/file"));
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("\\dir\\file", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_er(netwib_path_canon(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "/dir/file"));
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("\\\\comp", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_er(netwib_path_canon(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "/comp"));
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("\\\\comp\\", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_er(netwib_path_canon(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "/comp"));
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("\\\\comp\\dir\\", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_er(netwib_path_canon(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "\\\\comp\\dir\\"));
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("\\\\comp\\dir\\file", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_er(netwib_path_canon(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "\\\\comp\\dir\\file"));
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("\\\\comp\\dir\\file/", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_er(netwib_path_canon(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "\\\\comp\\dir\\file"));
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("\\\\comp\\dir/file", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_er(netwib_path_canon(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "\\\\comp\\dir\\file"));
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("\\\\comp\\sh/dir/..\\file", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_er(netwib_path_canon(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "\\\\comp\\sh\\file"));
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("d:", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_er(netwib_path_canon(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "d:."));
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("d:file", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_er(netwib_path_canon(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "d:./file"));
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("d:dir/", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_er(netwib_path_canon(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "d:./dir"));
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("d:dir/file", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_er(netwib_path_canon(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "d:./dir/file"));
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("d:dir/../file", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_er(netwib_path_canon(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "d:./file"));
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("d:dir/../../file", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_er(netwib_path_canon(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "d:../file"));
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("c:\\..", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_eir(netwib_path_canon(&buf1, &buf2), NETWIB_ERR_SPPATHROOTDOTDOT);
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("c:\\..\\", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_eir(netwib_path_canon(&buf1, &buf2), NETWIB_ERR_SPPATHROOTDOTDOT);
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("\\\\comp\\sh\\..\\", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_eir(netwib_path_canon(&buf1, &buf2), NETWIB_ERR_SPPATHROOTDOTDOT);
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_eir(netwib_path_canon(&buf1, &buf2), NETWIB_ERR_SPPATHNOTCLEANED);
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("./file", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_er(netwib_path_canon(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "./file"));
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("./dir/file", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_er(netwib_path_canon(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "./dir/file"));
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("/file", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_er(netwib_path_canon(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "/file"));
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("/dir/file", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_er(netwib_path_canon(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "/dir/file"));
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("../file", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_er(netwib_path_canon(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "../file"));
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("../dir/file", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_er(netwib_path_canon(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "../dir/file"));
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("../dir/dir", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_er(netwib_path_canon(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "../dir/dir"));
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("/", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_er(netwib_path_canon(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "/"));
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text(".", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_er(netwib_path_canon(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "."));
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("c:./file", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_er(netwib_path_canon(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "c:./file"));
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("c:./dir/file", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_er(netwib_path_canon(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "c:./dir/file"));
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("c:/file", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_er(netwib_path_canon(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "c:/file"));
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("c:./dir/file", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_er(netwib_path_canon(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "c:./dir/file"));
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("c:/file", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_er(netwib_path_canon(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "c:/file"));
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("c:/dir/file", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_er(netwib_path_canon(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "c:/dir/file"));
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("c:../file", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_er(netwib_path_canon(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "c:../file"));
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("c:../dir/file", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_er(netwib_path_canon(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "c:../dir/file"));
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("c:/", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_er(netwib_path_canon(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "c:/"));
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("c:.", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_er(netwib_path_canon(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "c:."));
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("\\\\s\\sh\\file", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_er(netwib_path_canon(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "\\\\s\\sh\\file"));
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("\\\\s\\sh\\dir/file", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_er(netwib_path_canon(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "\\\\s\\sh\\dir/file"));
  netwib_er(netwib_buf_close(&buf2));

  netwib_er(netwib_buf_init_ext_text("\\\\s\\sh\\", &buf1));
  netwib_er(netwib_buf_init_mallocdefault(&buf2));
  netwib_er(netwib_path_canon(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "\\\\s\\sh\\"));
  netwib_er(netwib_buf_close(&buf2));

  return(NETWIB_ERR_OK);
}

/*-------------------------------------------------------------*/
static netwib_err netwib_path_check_test(void)
{
  netwib_buf buf;
  netwib_bool b;

  puts("++++----\nTest of netwib_path_check");

  netwib_er(netwib_buf_init_ext_text("./file", &buf));
  netwib_er(netwib_path_check_absolute(&buf, &b));
  if (b) { return(NETWIBTEST_ERR_6); }
  netwib_er(netwib_path_check_relative(&buf, &b));
  if (!b) { return(NETWIBTEST_ERR_7); }
  netwib_er(netwib_path_check_root(&buf, &b));
  if (b) { return(NETWIBTEST_ERR_8); }
  netwib_er(netwib_path_check_start(&buf, &b));
  if (b) { return(NETWIBTEST_ERR_9); }

  netwib_er(netwib_buf_init_ext_text("/file", &buf));
  netwib_er(netwib_path_check_absolute(&buf, &b));
  if (!b) { return(NETWIBTEST_ERR_6); }
  netwib_er(netwib_path_check_relative(&buf, &b));
  if (b) { return(NETWIBTEST_ERR_7); }
  netwib_er(netwib_path_check_root(&buf, &b));
  if (b) { return(NETWIBTEST_ERR_8); }
  netwib_er(netwib_path_check_start(&buf, &b));
  if (b) { return(NETWIBTEST_ERR_9); }

  netwib_er(netwib_buf_init_ext_text("../file", &buf));
  netwib_er(netwib_path_check_absolute(&buf, &b));
  if (b) { return(NETWIBTEST_ERR_6); }
  netwib_er(netwib_path_check_relative(&buf, &b));
  if (!b) { return(NETWIBTEST_ERR_7); }
  netwib_er(netwib_path_check_root(&buf, &b));
  if (b) { return(NETWIBTEST_ERR_8); }
  netwib_er(netwib_path_check_start(&buf, &b));
  if (b) { return(NETWIBTEST_ERR_9); }

  netwib_er(netwib_buf_init_ext_text("/", &buf));
  netwib_er(netwib_path_check_absolute(&buf, &b));
  if (!b) { return(NETWIBTEST_ERR_6); }
  netwib_er(netwib_path_check_relative(&buf, &b));
  if (b) { return(NETWIBTEST_ERR_7); }
  netwib_er(netwib_path_check_root(&buf, &b));
  if (!b) { return(NETWIBTEST_ERR_8); }
  netwib_er(netwib_path_check_start(&buf, &b));
  if (!b) { return(NETWIBTEST_ERR_9); }

  netwib_er(netwib_buf_init_ext_text(".", &buf));
  netwib_er(netwib_path_check_absolute(&buf, &b));
  if (b) { return(NETWIBTEST_ERR_6); }
  netwib_er(netwib_path_check_relative(&buf, &b));
  if (!b) { return(NETWIBTEST_ERR_7); }
  netwib_er(netwib_path_check_root(&buf, &b));
  if (b) { return(NETWIBTEST_ERR_8); }
  netwib_er(netwib_path_check_start(&buf, &b));
  if (!b) { return(NETWIBTEST_ERR_9); }

  netwib_er(netwib_buf_init_ext_text("c:./file", &buf));
  netwib_er(netwib_path_check_absolute(&buf, &b));
  if (b) { return(NETWIBTEST_ERR_6); }
  netwib_er(netwib_path_check_relative(&buf, &b));
  if (b) { return(NETWIBTEST_ERR_7); }
  netwib_er(netwib_path_check_root(&buf, &b));
  if (b) { return(NETWIBTEST_ERR_8); }
  netwib_er(netwib_path_check_start(&buf, &b));
  if (b) { return(NETWIBTEST_ERR_9); }

  netwib_er(netwib_buf_init_ext_text("c:/file", &buf));
  netwib_er(netwib_path_check_absolute(&buf, &b));
  if (!b) { return(NETWIBTEST_ERR_6); }
  netwib_er(netwib_path_check_relative(&buf, &b));
  if (b) { return(NETWIBTEST_ERR_7); }
  netwib_er(netwib_path_check_root(&buf, &b));
  if (b) { return(NETWIBTEST_ERR_8); }
  netwib_er(netwib_path_check_start(&buf, &b));
  if (b) { return(NETWIBTEST_ERR_9); }

  netwib_er(netwib_buf_init_ext_text("c:../file", &buf));
  netwib_er(netwib_path_check_absolute(&buf, &b));
  if (b) { return(NETWIBTEST_ERR_6); }
  netwib_er(netwib_path_check_relative(&buf, &b));
  if (b) { return(NETWIBTEST_ERR_7); }
  netwib_er(netwib_path_check_root(&buf, &b));
  if (b) { return(NETWIBTEST_ERR_8); }
  netwib_er(netwib_path_check_start(&buf, &b));
  if (b) { return(NETWIBTEST_ERR_9); }

  netwib_er(netwib_buf_init_ext_text("c:/", &buf));
  netwib_er(netwib_path_check_absolute(&buf, &b));
  if (!b) { return(NETWIBTEST_ERR_6); }
  netwib_er(netwib_path_check_relative(&buf, &b));
  if (b) { return(NETWIBTEST_ERR_7); }
  netwib_er(netwib_path_check_root(&buf, &b));
  if (!b) { return(NETWIBTEST_ERR_8); }
  netwib_er(netwib_path_check_start(&buf, &b));
  if (!b) { return(NETWIBTEST_ERR_9); }

  netwib_er(netwib_buf_init_ext_text("c:.", &buf));
  netwib_er(netwib_path_check_absolute(&buf, &b));
  if (b) { return(NETWIBTEST_ERR_6); }
  netwib_er(netwib_path_check_relative(&buf, &b));
  if (b) { return(NETWIBTEST_ERR_7); }
  netwib_er(netwib_path_check_root(&buf, &b));
  if (b) { return(NETWIBTEST_ERR_8); }
  netwib_er(netwib_path_check_start(&buf, &b));
  if (!b) { return(NETWIBTEST_ERR_9); }

  netwib_er(netwib_buf_init_ext_text("\\\\s\\sh\\file", &buf));
  netwib_er(netwib_path_check_absolute(&buf, &b));
  if (!b) { return(NETWIBTEST_ERR_6); }
  netwib_er(netwib_path_check_relative(&buf, &b));
  if (b) { return(NETWIBTEST_ERR_7); }
  netwib_er(netwib_path_check_root(&buf, &b));
  if (b) { return(NETWIBTEST_ERR_8); }
  netwib_er(netwib_path_check_start(&buf, &b));
  if (b) { return(NETWIBTEST_ERR_9); }

  netwib_er(netwib_buf_init_ext_text("\\\\s\\sh\\", &buf));
  netwib_er(netwib_path_check_absolute(&buf, &b));
  if (!b) { return(NETWIBTEST_ERR_6); }
  netwib_er(netwib_path_check_relative(&buf, &b));
  if (b) { return(NETWIBTEST_ERR_7); }
  netwib_er(netwib_path_check_root(&buf, &b));
  if (!b) { return(NETWIBTEST_ERR_8); }
  netwib_er(netwib_path_check_start(&buf, &b));
  if (!b) { return(NETWIBTEST_ERR_9); }

  return(NETWIB_ERR_OK);
}

/*-------------------------------------------------------------*/
static netwib_err netwib_path_decode_test(void)
{
  netwib_buf buf1, buf2;

  puts("++++----\nTest of netwib_path_decode");

  netwib_er(netwib_buf_init_mallocdefault(&buf2));

  netwib_er(netwib_buf_init_ext_text("./file", &buf1));
  netwib_eir(netwib_path_decode_root(&buf1, &buf2), NETWIB_ERR_SPPATHRELATIVE);
  netwib__buf_reinit(&buf2);
  netwib_er(netwib_path_decode_start(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "."));
  netwib__buf_reinit(&buf2);
  netwib_er(netwib_path_decode_end(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "./file"));
  netwib__buf_reinit(&buf2);
  netwib_er(netwib_path_decode_parentdir(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "."));
  netwib__buf_reinit(&buf2);
  netwib_er(netwib_path_decode_lastitem(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "file"));

  netwib_er(netwib_buf_init_ext_text("/file", &buf1));
  netwib__buf_reinit(&buf2);
  netwib_er(netwib_path_decode_root(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "/"));
  netwib__buf_reinit(&buf2);
  netwib_er(netwib_path_decode_start(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "/"));
  netwib__buf_reinit(&buf2);
  netwib_er(netwib_path_decode_end(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "/file"));
  netwib__buf_reinit(&buf2);
  netwib_er(netwib_path_decode_parentdir(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "/"));
  netwib__buf_reinit(&buf2);
  netwib_er(netwib_path_decode_lastitem(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "file"));

  netwib_er(netwib_buf_init_ext_text("../file", &buf1));
  netwib__buf_reinit(&buf2);
  netwib_eir(netwib_path_decode_root(&buf1, &buf2), NETWIB_ERR_SPPATHRELATIVE);
  netwib__buf_reinit(&buf2);
  netwib_er(netwib_path_decode_start(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "."));
  netwib__buf_reinit(&buf2);
  netwib_er(netwib_path_decode_end(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "../file"));
  netwib__buf_reinit(&buf2);
  netwib_er(netwib_path_decode_parentdir(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, ".."));
  netwib__buf_reinit(&buf2);
  netwib_er(netwib_path_decode_lastitem(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "file"));

  netwib_er(netwib_buf_init_ext_text("/", &buf1));
  netwib__buf_reinit(&buf2);
  netwib_er(netwib_path_decode_root(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "/"));
  netwib__buf_reinit(&buf2);
  netwib_er(netwib_path_decode_start(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "/"));
  netwib__buf_reinit(&buf2);
  netwib_er(netwib_path_decode_end(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "/"));
  netwib__buf_reinit(&buf2);
  netwib_eir(netwib_path_decode_parentdir(&buf1, &buf2), NETWIB_ERR_SPPATHROOTDOTDOT);
  netwib__buf_reinit(&buf2);
  netwib_er(netwib_path_decode_lastitem(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "/"));

  netwib_er(netwib_buf_init_ext_text(".", &buf1));
  netwib__buf_reinit(&buf2);
  netwib_eir(netwib_path_decode_root(&buf1, &buf2), NETWIB_ERR_SPPATHRELATIVE);
  netwib__buf_reinit(&buf2);
  netwib_er(netwib_path_decode_start(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "."));
  netwib__buf_reinit(&buf2);
  netwib_er(netwib_path_decode_end(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "."));
  netwib__buf_reinit(&buf2);
  netwib_er(netwib_path_decode_parentdir(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, ".."));
  netwib__buf_reinit(&buf2);
  netwib_er(netwib_path_decode_lastitem(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "."));

  netwib_er(netwib_buf_init_ext_text("c:./file", &buf1));
  netwib__buf_reinit(&buf2);
  netwib_eir(netwib_path_decode_root(&buf1, &buf2), NETWIB_ERR_SPPATHRELATIVE);
  netwib__buf_reinit(&buf2);
  netwib_er(netwib_path_decode_start(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "c:."));
  netwib__buf_reinit(&buf2);
  netwib_er(netwib_path_decode_end(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "./file"));
  netwib__buf_reinit(&buf2);
  netwib_er(netwib_path_decode_parentdir(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "c:."));
  netwib__buf_reinit(&buf2);
  netwib_er(netwib_path_decode_lastitem(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "file"));

  netwib_er(netwib_buf_init_ext_text("c:/file", &buf1));
  netwib__buf_reinit(&buf2);
  netwib_er(netwib_path_decode_root(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "c:/"));
  netwib__buf_reinit(&buf2);
  netwib_er(netwib_path_decode_start(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "c:/"));
  netwib__buf_reinit(&buf2);
  netwib_er(netwib_path_decode_end(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "/file"));
  netwib__buf_reinit(&buf2);
  netwib_er(netwib_path_decode_parentdir(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "c:/"));
  netwib__buf_reinit(&buf2);
  netwib_er(netwib_path_decode_lastitem(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "file"));

  netwib_er(netwib_buf_init_ext_text("c:../file", &buf1));
  netwib__buf_reinit(&buf2);
  netwib_eir(netwib_path_decode_root(&buf1, &buf2), NETWIB_ERR_SPPATHRELATIVE);
  netwib__buf_reinit(&buf2);
  netwib_er(netwib_path_decode_start(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "c:."));
  netwib__buf_reinit(&buf2);
  netwib_er(netwib_path_decode_end(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "../file"));
  netwib__buf_reinit(&buf2);
  netwib_er(netwib_path_decode_parentdir(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "c:.."));
  netwib__buf_reinit(&buf2);
  netwib_er(netwib_path_decode_lastitem(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "file"));

  netwib_er(netwib_buf_init_ext_text("c:/", &buf1));
  netwib__buf_reinit(&buf2);
  netwib_er(netwib_path_decode_root(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "c:/"));
  netwib__buf_reinit(&buf2);
  netwib_er(netwib_path_decode_start(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "c:/"));
  netwib__buf_reinit(&buf2);
  netwib_er(netwib_path_decode_end(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "/"));
  netwib__buf_reinit(&buf2);
  netwib_eir(netwib_path_decode_parentdir(&buf1, &buf2), NETWIB_ERR_SPPATHROOTDOTDOT);
  netwib__buf_reinit(&buf2);
  netwib_er(netwib_path_decode_lastitem(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "/"));

  netwib_er(netwib_buf_init_ext_text("c:.", &buf1));
  netwib__buf_reinit(&buf2);
  netwib_eir(netwib_path_decode_root(&buf1, &buf2), NETWIB_ERR_SPPATHRELATIVE);
  netwib__buf_reinit(&buf2);
  netwib_er(netwib_path_decode_start(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "c:."));
  netwib__buf_reinit(&buf2);
  netwib_er(netwib_path_decode_end(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "."));
  netwib__buf_reinit(&buf2);
  netwib_er(netwib_path_decode_parentdir(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "c:.."));
  netwib__buf_reinit(&buf2);
  netwib_er(netwib_path_decode_lastitem(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "."));

  netwib_er(netwib_buf_init_ext_text("\\\\s\\sh\\file", &buf1));
  netwib__buf_reinit(&buf2);
  netwib_er(netwib_path_decode_root(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "\\\\s\\sh\\"));
  netwib__buf_reinit(&buf2);
  netwib_er(netwib_path_decode_start(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "\\\\s\\sh\\"));
  netwib__buf_reinit(&buf2);
  netwib_er(netwib_path_decode_end(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "/file"));
  netwib__buf_reinit(&buf2);
  netwib_er(netwib_path_decode_parentdir(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "\\\\s\\sh\\"));
  netwib__buf_reinit(&buf2);
  netwib_er(netwib_path_decode_lastitem(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "file"));

  netwib_er(netwib_buf_init_ext_text("\\\\s\\sh\\", &buf1));
  netwib__buf_reinit(&buf2);
  netwib_er(netwib_path_decode_root(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "\\\\s\\sh\\"));
  netwib__buf_reinit(&buf2);
  netwib_er(netwib_path_decode_start(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "\\\\s\\sh\\"));
  netwib__buf_reinit(&buf2);
  netwib_er(netwib_path_decode_end(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "/"));
  netwib__buf_reinit(&buf2);
  netwib_eir(netwib_path_decode_parentdir(&buf1, &buf2), NETWIB_ERR_SPPATHROOTDOTDOT);
  netwib__buf_reinit(&buf2);
  netwib_er(netwib_path_decode_lastitem(&buf1, &buf2));
  netwib_er(netwibtest_buf_content2(&buf2, "/"));

  netwib_er(netwib_buf_close(&buf2));

  return(NETWIB_ERR_OK);
}

/*-------------------------------------------------------------*/
static netwib_err it(netwib_uint32 func,
                     netwib_conststring dc,
                     netwib_conststring d1,
                     netwib_conststring p2,
                     netwib_err e,
                     netwib_conststring w)
{
  netwib_buf bufc, buf1, buf2, bufo;
  netwib_err ret;

  netwib_er(netwib_buf_init_ext_text(dc, &bufc));
  netwib_er(netwib_buf_init_ext_text(d1, &buf1));
  netwib_er(netwib_buf_init_ext_text(p2, &buf2));
  netwib_er(netwib_buf_init_mallocdefault(&bufo));

  ret = NETWIB_ERR_IEINTERNALERROR;
  switch (func) {
  case NETWIB_PATH_INITTYPE_CONCAT :
    ret = netwib_path_init_concat(&buf1, &buf2, &bufo);
    break;
  case NETWIB_PATH_INITTYPE_ABS :
    ret = netwib_path_init_abs(&buf1, &buf2, &bufo);
    break;
  case NETWIB_PATH_INITTYPE_RELA :
    ret = netwib_path_init_rela(&buf1, &buf2, &bufo);
    break;
  case NETWIB_PATH_INITTYPE_RELA2 :
    ret = netwib_path_init_rela2(&bufc, &buf1, &buf2, &bufo);
    break;
  case NETWIB_PATH_INITTYPE_RELB :
    ret = netwib_path_init_relb(&buf1, &buf2, &bufo);
    break;
  case NETWIB_PATH_INITTYPE_RELB2 :
    ret = netwib_path_init_relb2(&bufc, &buf1, &buf2, &bufo);
    break;
  }

  netwib_eir(ret, e);
  if (ret == NETWIB_ERR_OK) {
    netwib_er(netwibtest_buf_content2(&bufo, w));
  }

  netwib_er(netwib_buf_close(&bufo));

  return(NETWIB_ERR_OK);
}
#define it_concat(d1,p2,w) it(NETWIB_PATH_INITTYPE_CONCAT,"",d1,p2,NETWIB_ERR_OK,w)
#define it_concate(d1,p2,e) it(NETWIB_PATH_INITTYPE_CONCAT,"",d1,p2,e,NULL)
#define it_abs(d1,p2,w) it(NETWIB_PATH_INITTYPE_ABS,"",d1,p2,NETWIB_ERR_OK,w)
#define it_abse(d1,p2,e) it(NETWIB_PATH_INITTYPE_ABS,"",d1,p2,e,NULL)
#define it_rela(d1,p2,w) it(NETWIB_PATH_INITTYPE_RELA,"",d1,p2,NETWIB_ERR_OK,w)
#define it_relae(d1,p2,e) it(NETWIB_PATH_INITTYPE_RELA,"",d1,p2,e,NULL)
#define it_rela2(dc,d1,p2,w) it(NETWIB_PATH_INITTYPE_RELA2,dc,d1,p2,NETWIB_ERR_OK,w)
#define it_rela2e(dc,d1,p2,e) it(NETWIB_PATH_INITTYPE_RELA2,dc,d1,p2,e,NULL)
#define it_relb(d1,p2,w) it(NETWIB_PATH_INITTYPE_RELB,"",d1,p2,NETWIB_ERR_OK,w)
#define it_relbe(d1,p2,e) it(NETWIB_PATH_INITTYPE_RELB,"",d1,p2,e,NULL)
#define it_relb2(dc,d1,p2,w) it(NETWIB_PATH_INITTYPE_RELB2,dc,d1,p2,NETWIB_ERR_OK,w)
#define it_relb2e(dc,d1,p2,e) it(NETWIB_PATH_INITTYPE_RELB2,dc,d1,p2,e,NULL)

static netwib_err netwib_path_init_test(void)
{

  puts("++++----\nTest of netwib_path_init");

  netwib_er(it_concat("./d1", "./d2/f2", "./d1/d2/f2"));
  netwib_er(it_concat("./d1", "../d2/f2", "./d2/f2"));
  netwib_er(it_concate("./d1", "/d2/f2", NETWIB_ERR_SPPATHCANTINIT));
  netwib_er(it_concat("../d1", "./d2/f2", "../d1/d2/f2"));
  netwib_er(it_concat("../d1", "../d2/f2", "../d2/f2"));
  netwib_er(it_concate("../d1", "/d2/f2", NETWIB_ERR_SPPATHCANTINIT));
  netwib_er(it_concat("/d1", "./d2/f2", "/d1/d2/f2"));
  netwib_er(it_concat("/d1", "../d2/f2", "/d2/f2"));
  netwib_er(it_concate("/d1", "/d2/f2", NETWIB_ERR_SPPATHCANTINIT));
  netwib_er(it_concat("/", "/d2/f2", "/d2/f2"));
  netwib_er(it_concate("/d1", "c:./d2/f2", NETWIB_ERR_SPPATHCANTINIT));
  netwib_er(it_concate("/d1", "c:/d2/f2", NETWIB_ERR_SPPATHCANTINIT));
  netwib_er(it_concate("/d1", "c:../d2/f2", NETWIB_ERR_SPPATHCANTINIT));
  netwib_er(it_concate("/d1", "\\\\s\\s\\d2/f2", NETWIB_ERR_SPPATHCANTINIT));
  netwib_er(it_concat("c:.", "./d2/f2", "c:./d2/f2"));
  netwib_er(it_concat("c:/", "./d2/f2", "c:/d2/f2"));
  netwib_er(it_concat("\\\\s\\s\\", "/d2/f2", "\\\\s\\s\\d2/f2"));

  netwib_er(it_abse("./d1", "./d2/f2", NETWIB_ERR_SPPATHCANTINIT));
  netwib_er(it_abse("./d1", "../d2/f2", NETWIB_ERR_SPPATHCANTINIT));
  netwib_er(it_abs("./d1", "/d2/f2", "/d2/f2"));
  netwib_er(it_abse("../d1", "./d2/f2", NETWIB_ERR_SPPATHCANTINIT));
  netwib_er(it_abse("../d1", "../d2/f2", NETWIB_ERR_SPPATHCANTINIT));
  netwib_er(it_abs("../d1", "/d2/f2", "/d2/f2"));
  netwib_er(it_abs("/d1", "./d2/f2", "/d1/d2/f2"));
  netwib_er(it_abs("/d1", "../d2/f2", "/d2/f2"));
  netwib_er(it_abs("/d1", "/d2/f2", "/d2/f2"));
  netwib_er(it_abs("/", "/d2/f2", "/d2/f2"));
  netwib_er(it_abse("/d1", "c:./d2/f2", NETWIB_ERR_SPPATHCANTINIT));
  netwib_er(it_abs("/d1", "c:/d2/f2", "c:/d2/f2"));
  netwib_er(it_abse("/d1", "c:../d2/f2", NETWIB_ERR_SPPATHCANTINIT));
  netwib_er(it_abse("./d1", "c:./d2/f2", NETWIB_ERR_SPPATHCANTINIT));
  netwib_er(it_abs("./d1", "c:/d2/f2", "c:/d2/f2"));
  netwib_er(it_abse("./d1", "c:../d2/f2", NETWIB_ERR_SPPATHCANTINIT));
  netwib_er(it_abs("\\\\s\\s\\", "./d2/f2", "\\\\s\\s\\d2/f2"));
  netwib_er(it_abs("c:/", "./d2/f2", "c:/d2/f2"));
  netwib_er(it_abs("\\\\s\\s\\", "/d2/f2", "/d2/f2"));

  netwib_er(it_rela("./d1", "./d2/f2", "./d2/f2"));
  netwib_er(it_rela("./d1", "../d2/f2", "../d2/f2"));
  netwib_er(it_relae("./d1", "/d2/f2", NETWIB_ERR_SPPATHCANTINIT));
  netwib_er(it_rela2("/d", "./d1", "/d2/f2", "../../d2/f2"));
  netwib_er(it_rela("../d1", "./d2/f2", "./d2/f2"));
  netwib_er(it_rela("../d1", "../d2/f2", "../d2/f2"));
  netwib_er(it_relae("../d1", "/d2/f2", NETWIB_ERR_SPPATHCANTINIT));
  netwib_er(it_rela2("/d", "../d1", "/d2/f2", "../d2/f2"));
  netwib_er(it_rela("/d1", "./d2/f2", "./d2/f2"));
  netwib_er(it_rela("/d1", "../d2/f2", "../d2/f2"));
  netwib_er(it_rela("/d1", "/d2/f2", "../d2/f2"));
  netwib_er(it_rela("/", "/d2/f2", "./d2/f2"));
  netwib_er(it_relae("/d1", "c:./d2/f2", NETWIB_ERR_SPPATHCANTINIT));
  netwib_er(it_relae("/d1", "c:/d2/f2", NETWIB_ERR_SPPATHCANTINIT));
  netwib_er(it_relae("/d1", "c:../d2/f2", NETWIB_ERR_SPPATHCANTINIT));
  netwib_er(it_relae("./d1", "c:./d2/f2", NETWIB_ERR_SPPATHCANTINIT));
  netwib_er(it_relae("./d1", "c:/d2/f2", NETWIB_ERR_SPPATHCANTINIT));
  netwib_er(it_relae("./d1", "c:../d2/f2", NETWIB_ERR_SPPATHCANTINIT));
  netwib_er(it_relae("./d1", "\\\\s\\s\\d2/f2", NETWIB_ERR_SPPATHCANTINIT));
  netwib_er(it_relae("/d1", "\\\\s\\s\\d2/f2", NETWIB_ERR_SPPATHCANTINIT));
  netwib_er(it_relae("../d1", "\\\\s\\s\\d2/f2", NETWIB_ERR_SPPATHCANTINIT));
  netwib_er(it_relae("c:.", "/d2/f2", NETWIB_ERR_SPPATHCANTINIT));
  netwib_er(it_rela("c:/d1", "c:/d2/f2", "../d2/f2"));
  netwib_er(it_relae("c:/d1", "d:/d2/f2", NETWIB_ERR_SPPATHCANTINIT));
  netwib_er(it_rela("\\\\s\\sh\\d1", "\\\\s\\sh\\d2/f2", "../d2/f2"));
  netwib_er(it_relae("\\\\s\\sh\\d1", "\\\\s\\sh1\\d2/f2",
                     NETWIB_ERR_SPPATHCANTINIT));
  netwib_er(it_rela("/d1", "/d1/f2", "./f2"));
  netwib_er(it_rela("/d", "/d1/f2", "../d1/f2"));
  netwib_er(it_rela("/d11", "/d1/f2", "../d1/f2"));
  netwib_er(it_rela("/d1/f", "/d1/f2", "../f2"));
  netwib_er(it_rela("/d1/f2", "/d1/f2", "../f2"));
  netwib_er(it_rela("/d1/f22", "/d1/f2", "../f2"));
  netwib_er(it_rela("/d1/f2/f", "/d1/f2", "../../f2"));
  netwib_er(it_rela("/d1/f2/f", "/", "../../.."));
  netwib_er(it_rela("/d1/f2/f", "/d", "../../../d"));
  netwib_er(it_rela("/d1/f2/f", "/d11", "../../../d11"));
  netwib_er(it_rela("/d1/f2/f", "/d1", "../../../d1"));

  netwib_er(it_relb("./d1", "./d2/f2", "../d2/f2"));
  netwib_er(it_relb("./d1", "../d2/f2", "../../d2/f2"));
  netwib_er(it_relb2("/d", "./d1", "../d2/f2", "../../d2/f2"));
  netwib_er(it_relbe("./d1", "/d2/f2", NETWIB_ERR_SPPATHCANTINIT));
  netwib_er(it_relb2("/d", "./d1", "/d2/f2", "../../d2/f2"));
  netwib_er(it_relbe("../d1", "./d2/f2", NETWIB_ERR_SPPATHCANTINIT));
  netwib_er(it_relb2("/d", "../d1", "./d2/f2", "../d/d2/f2"));
  netwib_er(it_relb("../d1", "../d1/f2", "./f2"));
  netwib_er(it_relbe("../d1", "/d2/f2", NETWIB_ERR_SPPATHCANTINIT));
  netwib_er(it_relb2("/d", "../d1", "/d2/f2", "../d2/f2"));
  netwib_er(it_relbe("/d1", "./d2/f2", NETWIB_ERR_SPPATHCANTINIT));
  netwib_er(it_relb2("/d", "/d1", "./d2/f2", "../d/d2/f2"));
  netwib_er(it_relbe("/d1", "../d2/f2", NETWIB_ERR_SPPATHCANTINIT));
  netwib_er(it_relb2("/d", "/d1", "../d2/f2", "../d2/f2"));
  netwib_er(it_relb("/d1", "/d2/f2", "../d2/f2"));
  netwib_er(it_relb("./z", "./z/f", "./f"));

  return(NETWIB_ERR_OK);
}


/*-------------------------------------------------------------*/
/*-------------------------------------------------------------*/
netwib_err netwibtest_sys_path(void)
{
  puts("###########################################\nTest of sys/path");
  netwib_er(netwib_path_canon_test());
  netwib_er(netwib_path_check_test());
  netwib_er(netwib_path_decode_test());
  netwib_er(netwib_path_init_test());

  return(NETWIB_ERR_OK);
}

